Index: CMT/v1r25-branch/mgr/cmt_svn_checkout.py
===================================================================
--- CMT/v1r25-branch/mgr/cmt_svn_checkout.py	(revision 646)
+++ CMT/v1r25-branch/mgr/cmt_svn_checkout.py	(revision 664)
@@ -15,14 +15,15 @@
       --with_version_directory create version directory upon PATH checkout (default)
       --url=URL                checkout PATH from repository URL
+      --debug                  print lots of debugging information
   -h, --help                   display this help and exit
       --version                output version information and exit
 
-The SVNROOT, SVNTRUNK, SVNTAGS, and SVNBRANCHES environment variables specify repository URL of PATH, location of PATH trunk, tags, and branches (relatively to PATH) respectively.
+The SVNROOT, SVNTRUNK, SVNTAGS, and SVNBRANCHES (also SVNDEVBRANCHES) environment variables specify repository URL of PATH, location of PATH trunk, tags, and branches (also devbranches) (relatively to PATH) respectively.
 
 Report bugs to <CMT-L@IN2P3.FR>.
 """
 
-__version__ = '0.6.0'
-__date__ = 'Fri Mar 09 2012'
+__version__ = '0.8.0'
+__date__ = 'Wed Jul 31 2013'
 __author__ = 'Grigory Rybkin'
 
@@ -40,4 +41,6 @@
 import tempfile
 import re
+
+import logging
 
 self = 'cmt_svn_checkout.py'
@@ -298,4 +301,5 @@
                  tags = None,
                  branches = None,
+                 devbranches = None,
                  version = None,
                  version_dir = None,
@@ -307,4 +311,5 @@
         self.tags = tags
         self.branches = branches
+        self.devbranches = devbranches
         self.version = version
         self.version_dir = version_dir
@@ -327,4 +332,6 @@
         if self.branches is None:
             self.branches = os.getenv('SVNBRANCHES', 'branches')
+        if self.devbranches is None:
+            self.devbranches = os.getenv('SVNDEVBRANCHES', 'devbranches')
 
     def cmtRepos(self):
@@ -333,4 +340,5 @@
         self.tags= '.'
         self.branches = '.'
+        self.devbranches = '.'
 
     def add(self, module):
@@ -378,48 +386,152 @@
         """Attempt to determine the tag of the module's trunk.
         
-        Return the tag if its contents are the same as those of the trunk, and
-        its last_changed_rev is greater than the trunk created_rev, None otherwise.
+        Return the tag if its files are copied from the trunk and
+        their last_changed_rev numbers are the same as those of the trunk files.
         """
         trunk = posixpath.join(module.url, self.trunk)
 #        trunk = posixpath.normpath(posixpath.join(module.url, self.trunk))
+        cmd = 'svn ls -vR %s' % trunk
+        sc, out = Utils.getstatusoutput(cmd)
+        logger.debug('%s\n%s' % (cmd, out))
+        if sc != 0:
+            return None
+        trunk_dirent = [line.split() for line in out.splitlines()]
+        trunk_revs = dict([(line[-1], int(line[0])) for line in trunk_dirent if not line[-1].endswith(posixpath.sep)])
+        logger.debug('%s' % trunk_revs)
+
+        curdir = posixpath.curdir + posixpath.sep
+        for line in trunk_dirent:
+            if line[-1] == curdir:
+                class info(object): pass
+                info.last_changed_rev = int(line[0])
+                self.info_receiver(trunk, info, module)
+                logger.debug('last_changed_rev: %d' % info.last_changed_rev)
+                break
+
+#        cmd = 'svn info %s' % trunk
+#         p = r'last\s+changed\s+rev:\s+(?P<rev>\d+)'
+#         m = re.search(p, out, re.I)
+#         if m:
+#             class info(object): pass
+#             info.last_changed_rev = int(m.group('rev'))
+#             self.info_receiver(trunk, info, module)
+# #            self.info_receiver(trunk, info, None)
+# #             print >>sys.stderr, '%s: last_changed_rev %i' % \
+# #                   (trunk, self.info.last_changed_rev)
+# #            last_changed_rev = int(m.group('rev'))
+#         else:
+#             return None
+
+        tags = posixpath.join(module.url, self.tags)
+#        tags = posixpath.normpath(posixpath.join(module.url, self.tags))
+        cmd = 'svn ls -vR %s' % tags
+#        cmd = 'svn ls -v %s' % tags
+        sc, out = Utils.getstatusoutput(cmd)
+        logger.debug('%s\n%s' % (cmd, out))
+        if sc != 0:
+            return None
+        tags_dirent = [line.split() for line in out.splitlines()]
+        tags_revs = dict()
+        for ent in tags_dirent:
+            try:
+                tag, path = ent[-1].split(posixpath.sep, 1)
+            except ValueError:
+                continue
+            if tag not in tags_revs:
+                tags_revs[tag] = dict()
+            if path and not path.endswith(posixpath.sep):
+                # assume there are no empty directories in the tag
+                tags_revs[tag][path] = int(ent[0])
+        logger.debug('%s' % tags_revs)
+
         cmd = 'svn info %s' % trunk
         sc, out = Utils.getstatusoutput(cmd)
+        logger.debug('%s\n%s' % (cmd, out))
         if sc != 0:
             return None
-        p = r'last\s+changed\s+rev:\s+(?P<rev>\d+)'
+        p = r'repository\s+root:\s+(?P<root>%s://\S+)' % \
+            ('(?:' + '|'.join(map(re.escape, client_context.schemes)) + ')')
         m = re.search(p, out, re.I)
+        logger.debug('pattern: %r' % (p))
         if m:
-            class info(object): pass
-            info.last_changed_rev = int(m.group('rev'))
-            self.info_receiver(trunk, info, module)
-#            self.info_receiver(trunk, info, None)
-#             print >>sys.stderr, '%s: last_changed_rev %i' % \
-#                   (trunk, self.info.last_changed_rev)
-#            last_changed_rev = int(m.group('rev'))
+            root = m.group('root')
         else:
             return None
-
-        tags = posixpath.join(module.url, self.tags)
-#        tags = posixpath.normpath(posixpath.join(module.url, self.tags))
-        cmd = 'svn ls -v %s' % tags
+        logger.debug('root: %s' % root)
+        trunk_path = trunk[len(root):]
+        tags_path = tags[len(root):]
+        logger.debug('trunk_path: %s' % trunk_path)
+        logger.debug('tags_path: %s' % tags_path)
+        offset = len(trunk) - len(root) + len(posixpath.sep)
+        
+        # Usually, a tag is created as a server-side copy.
+        # Sometimes, a tag is created as a copy of WC (working copy)
+        # after commit.
+        # Below, we try to take into account the latter case.
+        cmd = 'svn log -v -q %s' % tags
         sc, out = Utils.getstatusoutput(cmd)
+        logger.debug('%s\n%s' % (cmd, out))
         if sc != 0:
             return None
-
-        tags_dirent = [line.split() for line in out.splitlines()]
-        rev_tag = dict([(int(line[0]), line[-1].rstrip(posixpath.sep)) for line in tags_dirent if line[-1].endswith(posixpath.sep)])
-        revs = rev_tag.keys()
-        revs.sort()
-        revs.reverse()
-
-        for rev in revs:
-            if rev < self.info.last_changed_rev: break
-#            if rev < last_changed_rev: break
-            tag = posixpath.join(tags, rev_tag[rev])
-#            tag = posixpath.normpath(posixpath.join(tags, rev_tag[rev]))
-            if 0 == self.cmp(trunk, tag, client_context):
-                return rev_tag[rev]
+        p = re.compile(
+            r'^-{5,}$\s^r\d+.+$\s^Changed paths:$\s^\s+A\s+%s%s(?P<tag>[^%s]+)\s+\(from %s:\d+\)$(?P<replaced>(?:\s^\s+(?:R|A|D)\s+%s%s(?P=tag)%s(?P<path>.+)(?:\s+\(from %s%s(?P=path):\d+\))?$)*)' % (re.escape(tags_path), posixpath.sep, posixpath.sep, re.escape(trunk_path), re.escape(tags_path), posixpath.sep, posixpath.sep, re.escape(trunk_path), posixpath.sep)
+            , re.M
+            )
+        tags_copied = list()
+        tags_replaced_revs = dict()
+        for m in p.finditer(out):
+            logger.debug('tag: %s replaced: %r' % (m.group('tag'), m.group('replaced')))
+            tags_copied.append(m.group('tag'))
+            for line in m.group('replaced').strip().splitlines():
+                l = line.split()
+                if len(l) == 2: continue # action code D - deleted paths
+                repl = l[3].rstrip(')')
+                i = repl.rindex(':')
+                path = repl[offset:i]
+                rev = int(repl[i + 1:])
+                logger.debug('path: %s rev: %d' % (path, rev))
+
+                if m.group('tag') not in tags_replaced_revs:
+                    tags_replaced_revs[m.group('tag')] = dict()
+                if path and not path.endswith(posixpath.sep):
+                    # assume there are no empty directories in the tag
+                    tags_replaced_revs[m.group('tag')][path] = rev
+
+        logger.debug('copied: %s' % tags_copied)
+        logger.debug('replaced: %s' % tags_replaced_revs)
+
+        for t in tags_revs.keys():
+            if t not in tags_copied:
+                del tags_revs[t]
+                logger.debug('%s: Not a trunk copy' % t)
+
+        for t in tags_replaced_revs:
+            if t in tags_revs:
+                tags_revs[t].update(tags_replaced_revs[t])
+                
+        for tag in tags_revs:
+            logger.debug('Compare: %s -> %s' % (tag, tags_revs[tag]))
+            if trunk_revs == tags_revs[tag]:
+                return tag
 
         return None
+
+#         tags_dirent = [line.split() for line in out.splitlines()]
+#         rev_tag = dict([(int(line[0]), line[-1].rstrip(posixpath.sep)) for line in tags_dirent if line[-1].endswith(posixpath.sep)])
+#         revs = rev_tag.keys()
+#         revs.sort()
+#         revs.reverse()
+
+#         for rev in revs:
+#             logger.debug('rev: %s' % rev)
+#             if rev < self.info.last_changed_rev: break
+# #            if rev < last_changed_rev: break
+#             tag = posixpath.join(tags, rev_tag[rev])
+# #            tag = posixpath.normpath(posixpath.join(tags, rev_tag[rev]))
+#             logger.debug('comparing: %s %s(%d)' % (trunk, tag, rev))
+#             if 0 == self.cmp(trunk, tag, client_context):
+#                 return rev_tag[rev]
+
+#         return None
 
 #         try:
@@ -496,5 +608,5 @@
             else:
                 m.URL = [posixpath.join(m.url, p, m.version)
-                         for p in (self.tags, self.branches)]
+                         for p in (self.tags, self.branches, self.devbranches)]
             m.URL = [client_context.svn_path_canonicalize(url) for url in m.URL]
 #            m.URL = [core.svn_path_canonicalize(url) for url in m.URL]
@@ -572,9 +684,16 @@
                                     "offset=", "no_config",
                                     "with_version_directory",
-                                    "without_version_directory", "url="])
+                                    "without_version_directory", "url=", "debug"])
     except getopt.error, e:
         print >>sys.stderr, '%s: %s' % (self, str(e))
         print >>sys.stderr, "Try '%s --help' for more information." % self
         return 1
+
+    global logger
+    logging.basicConfig()
+    logger = logging.getLogger(self)
+    logger.setLevel(logging.INFO)
+    if os.getenv('SVNDEBUG'):
+        logger.setLevel(logging.DEBUG)
 
     cmt_context = CmtContext()
@@ -605,4 +724,6 @@
         elif o in ("--url",):
             checkout.url = v
+        elif o in ("--debug",):
+            logger.setLevel(logging.DEBUG)
 
     if not args:
Index: CMT/v1r25-branch/mgr/fragments/application
===================================================================
--- CMT/v1r25-branch/mgr/fragments/application	(revision 646)
+++ CMT/v1r25-branch/mgr/fragments/application	(revision 664)
@@ -5,5 +5,5 @@
 	$(link_silent) ${LINKMACRO} -o $(@).new ${OBJS} $(cmt_installarea_linkopts) $(${CONSTITUENT}_use_linkopts) $(${CONSTITUENT}linkopts) && mv -f $(@).new $(@)
 
-ifdef use_stamps
+ifneq ($(strip $(use_stamps)),)
 # Work around Make errors if stamps files do not exist
 $(use_stamps) :
Index: CMT/v1r25-branch/mgr/fragments/nmake/package
===================================================================
--- CMT/v1r25-branch/mgr/fragments/nmake/package	(revision 646)
+++ CMT/v1r25-branch/mgr/fragments/nmake/package	(revision 664)
@@ -1,3 +1,4 @@
 
+cmt_${PACKAGE}_${ISINCLUDED} = 1
 cmt_${PACKAGE}_${ISLOCAL} = 1
 
@@ -6,4 +7,5 @@
 
 !if "$(LOG_LOCATION)" != ""
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 ${PACKAGE}OutErr = >>$(LOG_LOCATION)\$(${PACKAGE}FullName)$(LOG_SUFFIX) 2>&1
@@ -11,4 +13,5 @@
 !if "$(BCAST_GLOBAL)" != ""
 ${PACKAGE}OutErr = >>$(LOG_LOCATION)\$(${PACKAGE}FullName)$(LOG_SUFFIX) 2>&1
+!endif
 !endif
 !endif
@@ -20,4 +23,5 @@
 ${PACKAGE} : $(${PACKAGE}MgrPath)\NMake
 !endif
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 	@echo "#--------------------------------------------------------------" \
@@ -73,6 +77,10 @@
 !endif
 !endif
+!else
+	
+!endif
 
 $(${PACKAGE}MgrPath)\NMake :
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 	$(echo) configuring ${PACKAGE}
@@ -85,4 +93,7 @@
 	
 !endif
+!endif
+!else
+	
 !endif
 
@@ -96,4 +107,5 @@
 
 ${PACKAGE}clean : $(${PACKAGE}MgrPath)\NMake
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 	@echo "#--------------------------------------------------------------" \
@@ -125,6 +137,10 @@
 !endif
 !endif
+!else
+	
+!endif
 
 ${PACKAGE}binclean : $(${PACKAGE}MgrPath)\NMake
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 	@echo "#--------------------------------------------------------------" \
@@ -156,6 +172,10 @@
 !endif
 !endif
+!else
+	
+!endif
 
 ${PACKAGE}uninstall : $(${PACKAGE}MgrPath)\NMake
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 	@echo "#--------------------------------------------------------------" \
@@ -187,6 +207,10 @@
 !endif
 !endif
+!else
+	
+!endif
 
 ${PACKAGE}check : $(${PACKAGE}MgrPath)\NMake
+!if "$(cmt_${PACKAGE}_is_included)" != ""
 !if "$(cmt_${PACKAGE}_is_local)" != ""
 	@echo "#--------------------------------------------------------------" \
@@ -218,4 +242,7 @@
 !endif
 !endif
+!else
+	
+!endif
 
 ${PACKAGE} ${PACKAGE}clean ${PACKAGE}binclean ${PACKAGE}uninstall ${PACKAGE}check : FORCE
Index: CMT/v1r25-branch/mgr/fragments/nmake/packages_header
===================================================================
--- CMT/v1r25-branch/mgr/fragments/nmake/packages_header	(revision 646)
+++ CMT/v1r25-branch/mgr/fragments/nmake/packages_header	(revision 664)
@@ -27,5 +27,5 @@
 #    ignore: try all the groups even if one fails before going to the next package
 #            (may result in duplicated errors within a package)
-# Unix version taken from https://svnweb.cern.ch/trac/gaudi/browser/Gaudi/trunk/Makefile.cmt (Modified)
+# Unix version taken from https://svnweb.cern.ch/trac/gaudi/browser/Gaudi/trunk/Makefile.cmt (Modified by Grigory Rybkin)
 Package_failure_handler = || exit
 !if "$(PACKAGE_FAILURE_POLICY)" != ""
Index: CMT/v1r25-branch/mgr/fragments/package
===================================================================
--- CMT/v1r25-branch/mgr/fragments/package	(revision 646)
+++ CMT/v1r25-branch/mgr/fragments/package	(revision 664)
@@ -1,3 +1,4 @@
 
+cmt_${PACKAGE}_${ISINCLUDED} = 1
 cmt_${PACKAGE}_${ISLOCAL} = 1
 
@@ -6,4 +7,5 @@
 
 ifdef LOG_LOCATION
+ifdef cmt_${PACKAGE}_is_included
 ifdef cmt_${PACKAGE}_is_local
 ${PACKAGE}OutErr = >>$(LOG_LOCATION)/$(${PACKAGE}FullName)$(LOG_SUFFIX) 2>&1
@@ -11,4 +13,5 @@
 ifdef BCAST_GLOBAL
 ${PACKAGE}OutErr = >>$(LOG_LOCATION)/$(${PACKAGE}FullName)$(LOG_SUFFIX) 2>&1
+endif
 endif
 endif
@@ -20,4 +23,5 @@
 ${PACKAGE} : $(${PACKAGE}MgrPath)/Makefile
 endif
+ifdef cmt_${PACKAGE}_is_included
 ifdef cmt_${PACKAGE}_is_local
 	@echo "#--------------------------------------------------------------" \
@@ -67,6 +71,10 @@
 endif
 endif
+else
+	
+endif
 
 $(${PACKAGE}MgrPath)/Makefile :
+ifdef cmt_${PACKAGE}_is_included
 ifdef cmt_${PACKAGE}_is_local
 	$(echo) configuring ${PACKAGE}
@@ -80,4 +88,7 @@
 endif
 endif
+else
+	
+endif
 
 ifndef BCAST_ONLY
@@ -90,4 +101,5 @@
 
 ${PACKAGE}clean ${PACKAGE}binclean ${PACKAGE}uninstall ${PACKAGE}check : $(${PACKAGE}MgrPath)/Makefile
+ifdef cmt_${PACKAGE}_is_included
 ifdef cmt_${PACKAGE}_is_local
 	@echo "#--------------------------------------------------------------" \
@@ -119,4 +131,7 @@
 endif
 endif
+else
+	
+endif
 
 ${PACKAGE} ${PACKAGE}clean ${PACKAGE}binclean ${PACKAGE}uninstall ${PACKAGE}check : FORCE
Index: CMT/v1r25-branch/mgr/fragments/packages_header
===================================================================
--- CMT/v1r25-branch/mgr/fragments/packages_header	(revision 646)
+++ CMT/v1r25-branch/mgr/fragments/packages_header	(revision 664)
@@ -42,5 +42,5 @@
 #    ignore: try all the groups even if one fails before going to the next package
 #            (may result in duplicated errors within a package)
-# Taken from https://svnweb.cern.ch/trac/gaudi/browser/Gaudi/trunk/Makefile.cmt (Modified)
+# Taken from https://svnweb.cern.ch/trac/gaudi/browser/Gaudi/trunk/Makefile.cmt (Modified by Grigory Rybkin)
 Package_failure_handler = || exit
 ifdef PACKAGE_FAILURE_POLICY
Index: CMT/v1r25-branch/mgr/requirements
===================================================================
--- CMT/v1r25-branch/mgr/requirements	(revision 646)
+++ CMT/v1r25-branch/mgr/requirements	(revision 664)
@@ -6,6 +6,7 @@
 tag CMTr16 CMTr14
 tag CMTr18 CMTr16
-tag CMTr0  CMTr18
-
+tag CMTr0  CMTr25
+
+tag CMTv0  CMTv1
 #
 #  Automatic detection of some system features.
@@ -125,5 +126,5 @@
              WIN32     "CMT\v"
 
-path_prepend PATH      "${CMTROOT}/${CMTBIN}" \
+path_append  PATH      "${CMTROOT}/${CMTBIN}" \
              WIN32     "%CMTROOT%\%CMTBIN%"
 
Index: CMT/v1r25-branch/source/cmt.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt.h
===================================================================
--- CMT/v1r25-branch/source/cmt.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -24,4 +25,5 @@
 
   void clear ();
+  int initialize ();
 
   ActionType m_action;
@@ -34,4 +36,5 @@
   cmt_string m_cmt_version;
   bool m_use_cmt;
+  bool m_use_projects;
   
   cmt_string m_current_dir;
@@ -52,5 +55,10 @@
   cmt_string m_current_version;
   
-  cmt_string m_extra_tags;
+  //  cmt_string m_extra_tags;
+  CmtSystem::cmt_string_vector m_extra_tags;
+  CmtSystem::cmt_string_vector m_tags;
+  CmtSystem::cmt_string_vector m_tags_add;
+  CmtSystem::cmt_string_vector m_tags_remove;
+
   cmt_string m_configure_error;
   
@@ -68,4 +76,13 @@
 
   bool m_autoconfigure_cmtpath;
+
+  bool m_env_access;
+  PrintMode m_print_mode;
+  bool m_strip_path;
+
+private:
+
+  CmtContext& operator = (const CmtContext& other);
+  CmtContext (const CmtContext& other);
 };
 
@@ -79,5 +96,5 @@
   static void build_vsnet_file (const cmt_string& target);
 
-  static bool build_nmake ();
+  static inline bool build_nmake ();
   static void build_OS9_makefile (const cmt_string& target);
   static void build_prefix (const cmt_string& package, cmt_string& prefix);
@@ -90,5 +107,6 @@
   static void configure_current_cmtpath ();
   static void configure_current_dir ();
-  static void configure_current_package ();
+  static cmt_string configure_current_package ();
+  //  static void configure_current_package ();
   //  static void configure_current_structuring_style ();
   static void configure_current_structuring_style (const ArgParser& ap);
@@ -212,27 +230,28 @@
   static const cmt_string& filter_dir (const cmt_string& dir);
 
-  static ActionType get_action ();
-
-  static const cmt_string& get_cmt_home ();
-  static const cmt_string& get_cmt_user_context ();
-  static const cmt_string& get_cmt_version ();
-  static const cmt_string& get_current_dir ();
+  static inline ActionType get_action ();
+
+  static inline const cmt_string& get_cmt_home ();
+  static inline const cmt_string& get_cmt_user_context ();
+  static inline const cmt_string& get_cmt_version ();
+  static inline const cmt_string& get_current_dir ();
   static const cmt_string get_current_dir_real ();
-  static const cmt_string& get_current_package ();
+  static inline const cmt_string& get_current_package ();
   static const cmt_string& get_current_path ();
   static const cmt_string& get_current_cmtpath ();
   static const cmt_string& get_current_offset ();
-  static AccessMode get_current_access ();
-  static CmtStructuringStyle get_current_structuring_style ();
-  static CmtDirStyle get_current_style ();
+  static inline AccessMode get_current_access ();
+  static inline CmtStructuringStyle get_current_structuring_style ();
+  static inline CmtDirStyle get_current_style ();
   static const cmt_string& get_current_version ();
-  static const cmt_string& get_current_target ();
-  static bool get_debug ();
-  static bool get_disable_warnings ();  
-  static bool get_quiet ();
-  static bool get_warnings ();
-  static bool get_recursive ();
+  static inline const cmt_string& get_current_target ();
+  static inline const CmtSystem::cmt_string_vector& get_tags_remove ();
+  static inline bool get_debug ();
+  static inline bool get_disable_warnings ();  
+  static inline bool get_quiet ();
+  static inline bool get_warnings ();
+  static inline bool get_recursive ();
   static CmtScopeFilteringMode get_scope_filtering_mode ();
-  static bool get_all_sets_done ();
+  static inline bool get_all_sets_done ();
 
   static void get_cmt_flags (CmtSystem::cmt_string_vector& flags);
@@ -259,7 +278,9 @@
   static int parser (const cmt_string& command_line);
   static int parser (int argc, char* argv[]);
-  static void print (PrintMode mode);
+  static void print (PrintMode mode, ostream& out = cout);
+  //static void print (PrintMode mode);
   static void print_clean (PrintMode mode);
-  static void print_context (Use& use, PrintMode mode, const cmt_string& tag);
+  static void print_context (Use& use, PrintMode mode, const cmt_string& tag, ostream& out = cout);
+  //static void print_context (Use& use, PrintMode mode, const cmt_string& tag);
   static void print_macros (PrintMode mode, const cmt_string& pattern = "",
 			    ostream& out = cout);
@@ -268,13 +289,15 @@
   static void print_tabs (int tabs);
   static void print_xml_prolog (const cmt_string& root = "cmt", ostream& out = cout);
-  static int reach_current_package ();
+  //  static int reach_current_package ();
+  static int use_current_package ();
   static int use_extra_file (const cmt_string& file);
+  static int apply_globals ();
   static void restore_all_tags (Use* use);
-  static void set_current_access (AccessMode mode);
-  static void set_recursive (bool mode);
-  static void set_scope_filtering_mode (CmtScopeFilteringMode mode);
+  static inline void set_current_access (AccessMode mode);
+  static inline void set_recursive (bool mode);
+  static inline void set_scope_filtering_mode (CmtScopeFilteringMode mode);
   static void set_standard_macros ();
-  static void set_all_sets_done ();
-  static void reset_all_sets_done ();
+  static inline void set_all_sets_done ();
+  static inline void reset_all_sets_done ();
   static void use_cmt ();
   static void use_home_requirements ();
@@ -287,5 +310,159 @@
                                 const cmt_string& separator,
                                 cmt_string& result);
+
+  static inline const bool& get_env_access ();
+  static inline void set_env_access (const bool& access);
+  static inline const PrintMode& get_print_mode ();
+  static inline void set_print_mode (const PrintMode& mode);
+  static inline const bool& get_strip_path ();
+
+private:
+  static CmtContext& m_cmt_context;
+  //  static CmtContext * m_cmt_context;
 };
 
+//----------------------------------------------------------
+inline bool Cmt::build_nmake ()
+{
+  return (m_cmt_context.m_build_nmake);
+}
+
+inline ActionType Cmt::get_action ()
+{
+  return (m_cmt_context.m_action);
+}
+
+inline const cmt_string& Cmt::get_cmt_home ()
+{
+  return (m_cmt_context.m_cmt_home);
+}
+
+inline const cmt_string& Cmt::get_cmt_user_context ()
+{
+  return (m_cmt_context.m_cmt_user_context);
+}
+
+inline const cmt_string& Cmt::get_cmt_version ()
+{
+  return (m_cmt_context.m_cmt_version);
+}
+
+inline const cmt_string& Cmt::get_current_dir ()
+{
+  return (m_cmt_context.m_current_dir);
+}
+
+inline const cmt_string& Cmt::get_current_package ()
+{
+  return (m_cmt_context.m_current_package);
+}
+
+inline AccessMode Cmt::get_current_access ()
+{
+  return (m_cmt_context.m_current_access);
+}
+
+inline CmtStructuringStyle Cmt::get_current_structuring_style ()
+{
+  return (m_cmt_context.m_current_structuring_style);
+}
+
+inline CmtDirStyle Cmt::get_current_style ()
+{
+  return (m_cmt_context.m_current_style);
+}
+
+inline const cmt_string& Cmt::get_current_target ()
+{
+  return (m_cmt_context.m_current_target);
+}
+
+inline const CmtSystem::cmt_string_vector& Cmt::get_tags_remove ()
+{
+  return m_cmt_context.m_tags_remove;
+}
+
+inline bool Cmt::get_debug ()
+{
+  return (m_cmt_context.m_debug);
+}
+
+inline bool Cmt::get_quiet ()
+{
+  return (m_cmt_context.m_quiet);
+}
+
+inline bool Cmt::get_disable_warnings ()
+{
+  return (m_cmt_context.m_disable_warnings);
+}
+
+inline bool Cmt::get_warnings ()
+{
+  return (m_cmt_context.m_warnings);
+}
+
+inline bool Cmt::get_recursive ()
+{
+  return (m_cmt_context.m_recursive);
+}
+
+inline bool Cmt::get_all_sets_done ()
+{
+  return (m_cmt_context.m_all_sets_done);
+}
+
+inline void Cmt::set_current_access (AccessMode mode)
+{
+  m_cmt_context.m_current_access = mode;
+}
+
+//----------------------------------------------------------
+inline void Cmt::set_recursive (bool mode)
+{
+  m_cmt_context.m_recursive = mode;
+}
+
+//----------------------------------------------------------
+inline void Cmt::set_scope_filtering_mode (CmtScopeFilteringMode mode)
+{
+  m_cmt_context.m_scope_filtering_mode = mode;
+}
+
+inline void Cmt::set_all_sets_done ()
+{
+  m_cmt_context.m_all_sets_done = true;
+}
+
+inline void Cmt::reset_all_sets_done ()
+{
+  m_cmt_context.m_all_sets_done = false;
+}
+
+inline const bool& Cmt::get_env_access ()
+{
+  return m_cmt_context.m_env_access;
+}
+
+inline void Cmt::set_env_access (const bool& access)
+{
+  m_cmt_context.m_env_access = access;
+}
+
+inline const PrintMode& Cmt::get_print_mode ()
+{
+  return m_cmt_context.m_print_mode;
+}
+
+inline void Cmt::set_print_mode (const PrintMode& mode)
+{
+  m_cmt_context.m_print_mode = mode;
+}
+
+inline const bool& Cmt::get_strip_path ()
+{
+  return m_cmt_context.m_strip_path;
+}
+//----------------------------------------------------------
+
 #endif
Index: CMT/v1r25-branch/source/cmt_awk.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_awk.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_awk.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_cmtpath_pattern.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_cmtpath_pattern.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_cmtpath_pattern.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_cmtpath_pattern.h
===================================================================
--- CMT/v1r25-branch/source/cmt_cmtpath_pattern.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_cmtpath_pattern.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
